# Configurations ## ValidateRunnerConfiguration `client.Runners.Configurations.Validate(ctx, body) (*RunnerConfigurationValidateResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/ValidateRunnerConfiguration` Validates a runner configuration. Use this method to: - Check configuration validity - Verify integration settings - Validate environment classes ### Examples - Validate SCM integration: Checks if an SCM integration is valid. ```yaml runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" scmIntegration: id: "integration-id" scmId: "github" host: "github.com" oauthClientId: "client_id" oauthPlaintextClientSecret: "client_secret" ``` ### Parameters - `body RunnerConfigurationValidateParams` - `EnvironmentClass param.Field[EnvironmentClass]` - `RunnerID param.Field[string]` - `ScmIntegration param.Field[RunnerConfigurationValidateParamsScmIntegration]` - `ID string` id is the unique identifier of the SCM integration - `Host string` - `IssuerURL string` issuer_url can be set to override the authentication provider URL, if it doesn't match the SCM host. - `OAuthClientID string` oauth_client_id is the OAuth app's client ID, if OAuth is configured. If configured, oauth_client_secret must also be set. - `OAuthEncryptedClientSecret string` oauth_encrypted_client_secret is the OAuth app's client secret encrypted with the runner's public key, if OAuth is configured. This can be used to e.g. validate an already encrypted client secret of an existing SCM integration. - `OAuthPlaintextClientSecret string` oauth_plaintext_client_secret is the OAuth app's client secret in clear text, if OAuth is configured. This can be set to validate any new client secret before it is encrypted and stored. This value will not be stored and get encrypted with the runner's public key before passing it to the runner. - `Pat bool` - `ScmID string` scm_id references the scm_id in the runner's configuration schema that this integration is for - `VirtualDirectory string` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Returns - `type RunnerConfigurationValidateResponse struct{…}` - `EnvironmentClass EnvironmentClassValidationResult` - `ConfigurationErrors []FieldValidationError` - `Error string` - `Key string` - `DescriptionError string` - `DisplayNameError string` - `Valid bool` - `ScmIntegration ScmIntegrationValidationResult` - `HostError string` - `OAuthError string` - `PatError string` - `ScmIDError string` - `Valid bool` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) response, err := client.Runners.Configurations.Validate(context.TODO(), gitpod.RunnerConfigurationValidateParams{ RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), ScmIntegration: gitpod.F(gitpod.RunnerConfigurationValidateParamsScmIntegration{ Host: gitpod.F("github.com"), ID: gitpod.F("integration-id"), OAuthClientID: gitpod.F("client_id"), OAuthPlaintextClientSecret: gitpod.F("client_secret"), ScmID: gitpod.F("github"), }), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response.EnvironmentClass) } ``` #### Response ```json { "environmentClass": { "configurationErrors": [ { "error": "error", "key": "key" } ], "descriptionError": "descriptionError", "displayNameError": "displayNameError", "valid": true }, "scmIntegration": { "hostError": "hostError", "oauthError": "oauthError", "patError": "patError", "scmIdError": "scmIdError", "valid": true } } ``` ## Domain Types ### Environment Class Validation Result - `type EnvironmentClassValidationResult struct{…}` - `ConfigurationErrors []FieldValidationError` - `Error string` - `Key string` - `DescriptionError string` - `DisplayNameError string` - `Valid bool` ### Field Validation Error - `type FieldValidationError struct{…}` - `Error string` - `Key string` ### Scm Integration Validation Result - `type ScmIntegrationValidationResult struct{…}` - `HostError string` - `OAuthError string` - `PatError string` - `ScmIDError string` - `Valid bool` # Environment Classes ## CreateEnvironmentClass `client.Runners.Configurations.EnvironmentClasses.New(ctx, body) (*RunnerConfigurationEnvironmentClassNewResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/CreateEnvironmentClass` Creates a new environment class for a runner. Use this method to: - Define compute resources - Configure environment settings - Set up runtime options ### Examples - Create environment class: Creates a new environment configuration. ```yaml runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" displayName: "Large Instance" description: "8 CPU, 16GB RAM" configuration: - key: "cpu" value: "8" - key: "memory" value: "16384" ``` ### Parameters - `body RunnerConfigurationEnvironmentClassNewParams` - `Configuration param.Field[[]FieldValue]` - `Key string` - `Value string` - `Description param.Field[string]` - `DisplayName param.Field[string]` - `RunnerID param.Field[string]` ### Returns - `type RunnerConfigurationEnvironmentClassNewResponse struct{…}` - `ID string` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" "github.com/gitpod-io/gitpod-sdk-go/shared" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) environmentClass, err := client.Runners.Configurations.EnvironmentClasses.New(context.TODO(), gitpod.RunnerConfigurationEnvironmentClassNewParams{ Configuration: gitpod.F([]shared.FieldValueParam{shared.FieldValueParam{ Key: gitpod.F("cpu"), Value: gitpod.F("8"), }, shared.FieldValueParam{ Key: gitpod.F("memory"), Value: gitpod.F("16384"), }}), Description: gitpod.F("8 CPU, 16GB RAM"), DisplayName: gitpod.F("Large Instance"), RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", environmentClass.ID) } ``` #### Response ```json { "id": "id" } ``` ## ListEnvironmentClasses `client.Runners.Configurations.EnvironmentClasses.List(ctx, params) (*EnvironmentClassesPage[EnvironmentClass], error)` **post** `/gitpod.v1.RunnerConfigurationService/ListEnvironmentClasses` Lists environment classes with optional filtering. Use this method to: - View available classes - Filter by capability - Check enabled status ### Examples - List all classes: Shows all environment classes. ```yaml pagination: pageSize: 20 ``` - Filter enabled classes: Lists only enabled environment classes. ```yaml filter: enabled: true pagination: pageSize: 20 ``` buf:lint:ignore RPC_REQUEST_RESPONSE_UNIQUE ### Parameters - `params RunnerConfigurationEnvironmentClassListParams` - `Token param.Field[string]` Query param - `PageSize param.Field[int64]` Query param - `Filter param.Field[RunnerConfigurationEnvironmentClassListParamsFilter]` Body param - `CanCreateEnvironments bool` can_create_environments filters the response to only environment classes that can be used to create new environments by the caller. Unlike enabled, which indicates general availability, this ensures the caller only sees environment classes they are allowed to use. - `Enabled bool` enabled filters the response to only enabled or disabled environment classes. If not set, all environment classes are returned. - `RunnerIDs []string` runner_ids filters the response to only EnvironmentClasses of these Runner IDs - `RunnerKinds []RunnerKind` runner_kind filters the response to only environment classes from runners of these kinds. - `const RunnerKindUnspecified RunnerKind = "RUNNER_KIND_UNSPECIFIED"` - `const RunnerKindLocal RunnerKind = "RUNNER_KIND_LOCAL"` - `const RunnerKindRemote RunnerKind = "RUNNER_KIND_REMOTE"` - `const RunnerKindLocalConfiguration RunnerKind = "RUNNER_KIND_LOCAL_CONFIGURATION"` - `RunnerProviders []RunnerProvider` runner_providers filters the response to only environment classes from runners of these providers. - `const RunnerProviderUnspecified RunnerProvider = "RUNNER_PROVIDER_UNSPECIFIED"` - `const RunnerProviderAwsEc2 RunnerProvider = "RUNNER_PROVIDER_AWS_EC2"` - `const RunnerProviderLinuxHost RunnerProvider = "RUNNER_PROVIDER_LINUX_HOST"` - `const RunnerProviderDesktopMac RunnerProvider = "RUNNER_PROVIDER_DESKTOP_MAC"` - `const RunnerProviderManaged RunnerProvider = "RUNNER_PROVIDER_MANAGED"` - `const RunnerProviderGcp RunnerProvider = "RUNNER_PROVIDER_GCP"` - `const RunnerProviderDevAgent RunnerProvider = "RUNNER_PROVIDER_DEV_AGENT"` - `Pagination param.Field[RunnerConfigurationEnvironmentClassListParamsPagination]` Body param: pagination contains the pagination options for listing environment classes - `Token string` Token for the next set of results that was returned as next_token of a PaginationResponse - `PageSize int64` Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. ### Returns - `type EnvironmentClass struct{…}` - `ID string` id is the unique identifier of the environment class - `RunnerID string` runner_id is the unique identifier of the runner the environment class belongs to - `Configuration []FieldValue` configuration describes the configuration of the environment class - `Key string` - `Value string` - `Description string` description is a human readable description of the environment class - `DisplayName string` display_name is the human readable name of the environment class - `Enabled bool` enabled indicates whether the environment class can be used to create new environments. ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) page, err := client.Runners.Configurations.EnvironmentClasses.List(context.TODO(), gitpod.RunnerConfigurationEnvironmentClassListParams{ Filter: gitpod.F(gitpod.RunnerConfigurationEnvironmentClassListParamsFilter{ Enabled: gitpod.F(true), }), Pagination: gitpod.F(gitpod.RunnerConfigurationEnvironmentClassListParamsPagination{ PageSize: gitpod.F(int64(20)), }), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "environmentClasses": [ { "id": "id", "runnerId": "runnerId", "configuration": [ { "key": "key", "value": "value" } ], "description": "xxx", "displayName": "xxx", "enabled": true } ], "pagination": { "nextToken": "nextToken" } } ``` ## GetEnvironmentClass `client.Runners.Configurations.EnvironmentClasses.Get(ctx, body) (*RunnerConfigurationEnvironmentClassGetResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/GetEnvironmentClass` Gets details about a specific environment class. Use this method to: - View class configuration - Check resource settings - Verify availability ### Examples - Get class details: Retrieves information about a specific class. ```yaml environmentClassId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationEnvironmentClassGetParams` - `EnvironmentClassID param.Field[string]` ### Returns - `type RunnerConfigurationEnvironmentClassGetResponse struct{…}` - `EnvironmentClass EnvironmentClass` - `ID string` id is the unique identifier of the environment class - `RunnerID string` runner_id is the unique identifier of the runner the environment class belongs to - `Configuration []FieldValue` configuration describes the configuration of the environment class - `Key string` - `Value string` - `Description string` description is a human readable description of the environment class - `DisplayName string` display_name is the human readable name of the environment class - `Enabled bool` enabled indicates whether the environment class can be used to create new environments. ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) environmentClass, err := client.Runners.Configurations.EnvironmentClasses.Get(context.TODO(), gitpod.RunnerConfigurationEnvironmentClassGetParams{ EnvironmentClassID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", environmentClass.EnvironmentClass) } ``` #### Response ```json { "environmentClass": { "id": "id", "runnerId": "runnerId", "configuration": [ { "key": "key", "value": "value" } ], "description": "xxx", "displayName": "xxx", "enabled": true } } ``` ## UpdateEnvironmentClass `client.Runners.Configurations.EnvironmentClasses.Update(ctx, body) (*RunnerConfigurationEnvironmentClassUpdateResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/UpdateEnvironmentClass` Updates an environment class. Use this method to: - Modify class settings - Update resource limits - Change availability ### Examples - Update class: Changes class configuration. ```yaml environmentClassId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" displayName: "Updated Large Instance" description: "16 CPU, 32GB RAM" enabled: true ``` ### Parameters - `body RunnerConfigurationEnvironmentClassUpdateParams` - `Description param.Field[string]` - `DisplayName param.Field[string]` - `Enabled param.Field[bool]` - `EnvironmentClassID param.Field[string]` ### Returns - `type RunnerConfigurationEnvironmentClassUpdateResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) environmentClass, err := client.Runners.Configurations.EnvironmentClasses.Update(context.TODO(), gitpod.RunnerConfigurationEnvironmentClassUpdateParams{ Description: gitpod.F("16 CPU, 32GB RAM"), DisplayName: gitpod.F("Updated Large Instance"), Enabled: gitpod.F(true), EnvironmentClassID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", environmentClass) } ``` #### Response ```json {} ``` # Host Authentication Tokens ## CreateHostAuthenticationToken `client.Runners.Configurations.HostAuthenticationTokens.New(ctx, body) (*RunnerConfigurationHostAuthenticationTokenNewResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/CreateHostAuthenticationToken` Creates a new authentication token for accessing remote hosts. Use this method to: - Set up SCM authentication - Configure OAuth credentials - Manage PAT tokens ### Examples - Create OAuth token: Creates a new OAuth-based authentication token. ```yaml runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" userId: "f53d2330-3795-4c5d-a1f3-453121af9c60" host: "github.com" token: "gho_xxxxxxxxxxxx" source: HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH expiresAt: "2024-12-31T23:59:59Z" refreshToken: "ghr_xxxxxxxxxxxx" ``` ### Parameters - `body RunnerConfigurationHostAuthenticationTokenNewParams` - `Token param.Field[string]` stored encrypted, retrieved via GetHostAuthenticationTokenValue - `ExpiresAt param.Field[Time]` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `Host param.Field[string]` - `IntegrationID param.Field[string]` - `RefreshToken param.Field[string]` stored encrypted, retrieved via GetHostAuthenticationTokenValue - `RunnerID param.Field[string]` - `Scopes param.Field[[]string]` Maximum 100 scopes allowed (101 for validation purposes) - `Source param.Field[HostAuthenticationTokenSource]` - `Subject param.Field[Subject]` Subject identifies the principal (user or service account) for the token - `UserID param.Field[string]` Deprecated: Use principal_id and principal_type instead ### Returns - `type RunnerConfigurationHostAuthenticationTokenNewResponse struct{…}` - `Token HostAuthenticationToken` - `ID string` - `ExpiresAt Time` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `Host string` - `IntegrationID string` links to integration instance - `RunnerID string` - `Scopes []string` token permissions - `Source HostAuthenticationTokenSource` auth_type - `const HostAuthenticationTokenSourceUnspecified HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED"` - `const HostAuthenticationTokenSourceOAuth HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH"` - `const HostAuthenticationTokenSourcePat HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_PAT"` - `Subject Subject` Subject identifies the principal (user or service account) for the token Note: actual token and refresh_token values are retrieved via GetHostAuthenticationTokenValue API - `ID string` id is the UUID of the subject - `Principal Principal` Principal is the principal of the subject - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `UserID string` Deprecated: Use principal_id and principal_type instead principal (user) ### Example ```go package main import ( "context" "fmt" "time" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) hostAuthenticationToken, err := client.Runners.Configurations.HostAuthenticationTokens.New(context.TODO(), gitpod.RunnerConfigurationHostAuthenticationTokenNewParams{ Token: gitpod.F("gho_xxxxxxxxxxxx"), ExpiresAt: gitpod.F(time.Now()), Host: gitpod.F("github.com"), RefreshToken: gitpod.F("ghr_xxxxxxxxxxxx"), RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), Source: gitpod.F(gitpod.HostAuthenticationTokenSourceOAuth), UserID: gitpod.F("f53d2330-3795-4c5d-a1f3-453121af9c60"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", hostAuthenticationToken.Token) } ``` #### Response ```json { "token": { "id": "id", "expiresAt": "2019-12-27T18:11:19.117Z", "host": "host", "integrationId": "integrationId", "runnerId": "runnerId", "scopes": [ "string" ], "source": "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED", "subject": { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "principal": "PRINCIPAL_UNSPECIFIED" }, "userId": "userId" } } ``` ## DeleteHostAuthenticationToken `client.Runners.Configurations.HostAuthenticationTokens.Delete(ctx, body) (*RunnerConfigurationHostAuthenticationTokenDeleteResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/DeleteHostAuthenticationToken` Deletes a host authentication token. Use this method to: - Remove unused tokens - Revoke access - Clean up expired tokens ### Examples - Delete token: Permanently removes a token. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationHostAuthenticationTokenDeleteParams` - `ID param.Field[string]` ### Returns - `type RunnerConfigurationHostAuthenticationTokenDeleteResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) hostAuthenticationToken, err := client.Runners.Configurations.HostAuthenticationTokens.Delete(context.TODO(), gitpod.RunnerConfigurationHostAuthenticationTokenDeleteParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", hostAuthenticationToken) } ``` #### Response ```json {} ``` ## ListHostAuthenticationTokens `client.Runners.Configurations.HostAuthenticationTokens.List(ctx, params) (*TokensPage[HostAuthenticationToken], error)` **post** `/gitpod.v1.RunnerConfigurationService/ListHostAuthenticationTokens` Lists host authentication tokens with optional filtering. Use this method to: - View all tokens - Filter by runner or user - Monitor token status ### Examples - List all tokens: Shows all tokens with pagination. ```yaml pagination: pageSize: 20 ``` - Filter by runner: Lists tokens for a specific runner. ```yaml filter: runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" pagination: pageSize: 20 ``` ### Parameters - `params RunnerConfigurationHostAuthenticationTokenListParams` - `Token param.Field[string]` Query param - `PageSize param.Field[int64]` Query param - `Filter param.Field[RunnerConfigurationHostAuthenticationTokenListParamsFilter]` Body param - `RunnerID string` - `SubjectID string` Filter by subject (user or service account) - `UserID string` Deprecated: Use principal_id instead - `Pagination param.Field[RunnerConfigurationHostAuthenticationTokenListParamsPagination]` Body param - `Token string` Token for the next set of results that was returned as next_token of a PaginationResponse - `PageSize int64` Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. ### Returns - `type HostAuthenticationToken struct{…}` - `ID string` - `ExpiresAt Time` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `Host string` - `IntegrationID string` links to integration instance - `RunnerID string` - `Scopes []string` token permissions - `Source HostAuthenticationTokenSource` auth_type - `const HostAuthenticationTokenSourceUnspecified HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED"` - `const HostAuthenticationTokenSourceOAuth HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH"` - `const HostAuthenticationTokenSourcePat HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_PAT"` - `Subject Subject` Subject identifies the principal (user or service account) for the token Note: actual token and refresh_token values are retrieved via GetHostAuthenticationTokenValue API - `ID string` id is the UUID of the subject - `Principal Principal` Principal is the principal of the subject - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `UserID string` Deprecated: Use principal_id and principal_type instead principal (user) ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) page, err := client.Runners.Configurations.HostAuthenticationTokens.List(context.TODO(), gitpod.RunnerConfigurationHostAuthenticationTokenListParams{ Filter: gitpod.F(gitpod.RunnerConfigurationHostAuthenticationTokenListParamsFilter{ RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }), Pagination: gitpod.F(gitpod.RunnerConfigurationHostAuthenticationTokenListParamsPagination{ PageSize: gitpod.F(int64(20)), }), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "pagination": { "nextToken": "nextToken" }, "tokens": [ { "id": "id", "expiresAt": "2019-12-27T18:11:19.117Z", "host": "host", "integrationId": "integrationId", "runnerId": "runnerId", "scopes": [ "string" ], "source": "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED", "subject": { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "principal": "PRINCIPAL_UNSPECIFIED" }, "userId": "userId" } ] } ``` ## GetHostAuthenticationToken `client.Runners.Configurations.HostAuthenticationTokens.Get(ctx, body) (*RunnerConfigurationHostAuthenticationTokenGetResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/GetHostAuthenticationToken` Gets details about a specific host authentication token. Use this method to: - View token information - Check token expiration - Verify token validity ### Examples - Get token details: Retrieves information about a specific token. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationHostAuthenticationTokenGetParams` - `ID param.Field[string]` ### Returns - `type RunnerConfigurationHostAuthenticationTokenGetResponse struct{…}` - `Token HostAuthenticationToken` - `ID string` - `ExpiresAt Time` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `Host string` - `IntegrationID string` links to integration instance - `RunnerID string` - `Scopes []string` token permissions - `Source HostAuthenticationTokenSource` auth_type - `const HostAuthenticationTokenSourceUnspecified HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED"` - `const HostAuthenticationTokenSourceOAuth HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH"` - `const HostAuthenticationTokenSourcePat HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_PAT"` - `Subject Subject` Subject identifies the principal (user or service account) for the token Note: actual token and refresh_token values are retrieved via GetHostAuthenticationTokenValue API - `ID string` id is the UUID of the subject - `Principal Principal` Principal is the principal of the subject - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `UserID string` Deprecated: Use principal_id and principal_type instead principal (user) ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) hostAuthenticationToken, err := client.Runners.Configurations.HostAuthenticationTokens.Get(context.TODO(), gitpod.RunnerConfigurationHostAuthenticationTokenGetParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", hostAuthenticationToken.Token) } ``` #### Response ```json { "token": { "id": "id", "expiresAt": "2019-12-27T18:11:19.117Z", "host": "host", "integrationId": "integrationId", "runnerId": "runnerId", "scopes": [ "string" ], "source": "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED", "subject": { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e", "principal": "PRINCIPAL_UNSPECIFIED" }, "userId": "userId" } } ``` ## UpdateHostAuthenticationToken `client.Runners.Configurations.HostAuthenticationTokens.Update(ctx, body) (*RunnerConfigurationHostAuthenticationTokenUpdateResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/UpdateHostAuthenticationToken` Updates an existing host authentication token. Use this method to: - Refresh token values - Update expiration - Modify token settings ### Examples - Update token: Updates token value and expiration. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" token: "gho_xxxxxxxxxxxx" expiresAt: "2024-12-31T23:59:59Z" refreshToken: "ghr_xxxxxxxxxxxx" ``` ### Parameters - `body RunnerConfigurationHostAuthenticationTokenUpdateParams` - `ID param.Field[string]` - `Token param.Field[string]` - `ExpiresAt param.Field[Time]` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `RefreshToken param.Field[string]` - `Scopes param.Field[[]string]` ### Returns - `type RunnerConfigurationHostAuthenticationTokenUpdateResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "time" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) hostAuthenticationToken, err := client.Runners.Configurations.HostAuthenticationTokens.Update(context.TODO(), gitpod.RunnerConfigurationHostAuthenticationTokenUpdateParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), Token: gitpod.F("gho_xxxxxxxxxxxx"), ExpiresAt: gitpod.F(time.Now()), RefreshToken: gitpod.F("ghr_xxxxxxxxxxxx"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", hostAuthenticationToken) } ``` #### Response ```json {} ``` ## Domain Types ### Host Authentication Token - `type HostAuthenticationToken struct{…}` - `ID string` - `ExpiresAt Time` A Timestamp represents a point in time independent of any time zone or local calendar, encoded as a count of seconds and fractions of seconds at nanosecond resolution. The count is relative to an epoch at UTC midnight on January 1, 1970, in the proleptic Gregorian calendar which extends the Gregorian calendar backwards to year one. All minutes are 60 seconds long. Leap seconds are "smeared" so that no leap second table is needed for interpretation, using a [24-hour linear smear](https://developers.google.com/time/smear). The range is from 0001-01-01T00:00:00Z to 9999-12-31T23:59:59.999999999Z. By restricting to that range, we ensure that we can convert to and from [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) date strings. # Examples Example 1: Compute Timestamp from POSIX `time()`. Timestamp timestamp; timestamp.set_seconds(time(NULL)); timestamp.set_nanos(0); Example 2: Compute Timestamp from POSIX `gettimeofday()`. struct timeval tv; gettimeofday(&tv, NULL); Timestamp timestamp; timestamp.set_seconds(tv.tv_sec); timestamp.set_nanos(tv.tv_usec * 1000); Example 3: Compute Timestamp from Win32 `GetSystemTimeAsFileTime()`. FILETIME ft; GetSystemTimeAsFileTime(&ft); UINT64 ticks = (((UINT64)ft.dwHighDateTime) << 32) | ft.dwLowDateTime; // A Windows tick is 100 nanoseconds. Windows epoch 1601-01-01T00:00:00Z // is 11644473600 seconds before Unix epoch 1970-01-01T00:00:00Z. Timestamp timestamp; timestamp.set_seconds((INT64) ((ticks / 10000000) - 11644473600LL)); timestamp.set_nanos((INT32) ((ticks % 10000000) * 100)); Example 4: Compute Timestamp from Java `System.currentTimeMillis()`. long millis = System.currentTimeMillis(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(millis / 1000) .setNanos((int) ((millis % 1000) * 1000000)).build(); Example 5: Compute Timestamp from Java `Instant.now()`. Instant now = Instant.now(); Timestamp timestamp = Timestamp.newBuilder().setSeconds(now.getEpochSecond()) .setNanos(now.getNano()).build(); Example 6: Compute Timestamp from current time in Python. timestamp = Timestamp() timestamp.GetCurrentTime() # JSON Mapping In JSON format, the Timestamp type is encoded as a string in the [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format. That is, the format is "{year}-{month}-{day}T{hour}:{min}:{sec}[.{frac_sec}]Z" where {year} is always expressed using four digits while {month}, {day}, {hour}, {min}, and {sec} are zero-padded to two digits each. The fractional seconds, which can go up to 9 digits (i.e. up to 1 nanosecond resolution), are optional. The "Z" suffix indicates the timezone ("UTC"); the timezone is required. A proto3 JSON serializer should always use UTC (as indicated by "Z") when printing the Timestamp type and a proto3 JSON parser should be able to accept both UTC and other timezones (as indicated by an offset). For example, "2017-01-15T01:30:15.01Z" encodes 15.01 seconds past 01:30 UTC on January 15, 2017. In JavaScript, one can convert a Date object to this format using the standard [toISOString()](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString) method. In Python, a standard `datetime.datetime` object can be converted to this format using [`strftime`](https://docs.python.org/2/library/time.html#time.strftime) with the time format spec '%Y-%m-%dT%H:%M:%S.%fZ'. Likewise, in Java, one can use the Joda Time's [`ISODateTimeFormat.dateTime()`](http://joda-time.sourceforge.net/apidocs/org/joda/time/format/ISODateTimeFormat.html#dateTime\(\)) to obtain a formatter capable of generating timestamps in this format. - `Host string` - `IntegrationID string` links to integration instance - `RunnerID string` - `Scopes []string` token permissions - `Source HostAuthenticationTokenSource` auth_type - `const HostAuthenticationTokenSourceUnspecified HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED"` - `const HostAuthenticationTokenSourceOAuth HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH"` - `const HostAuthenticationTokenSourcePat HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_PAT"` - `Subject Subject` Subject identifies the principal (user or service account) for the token Note: actual token and refresh_token values are retrieved via GetHostAuthenticationTokenValue API - `ID string` id is the UUID of the subject - `Principal Principal` Principal is the principal of the subject - `const PrincipalUnspecified Principal = "PRINCIPAL_UNSPECIFIED"` - `const PrincipalAccount Principal = "PRINCIPAL_ACCOUNT"` - `const PrincipalUser Principal = "PRINCIPAL_USER"` - `const PrincipalRunner Principal = "PRINCIPAL_RUNNER"` - `const PrincipalEnvironment Principal = "PRINCIPAL_ENVIRONMENT"` - `const PrincipalServiceAccount Principal = "PRINCIPAL_SERVICE_ACCOUNT"` - `const PrincipalRunnerManager Principal = "PRINCIPAL_RUNNER_MANAGER"` - `UserID string` Deprecated: Use principal_id and principal_type instead principal (user) ### Host Authentication Token Source - `type HostAuthenticationTokenSource string` - `const HostAuthenticationTokenSourceUnspecified HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_UNSPECIFIED"` - `const HostAuthenticationTokenSourceOAuth HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_OAUTH"` - `const HostAuthenticationTokenSourcePat HostAuthenticationTokenSource = "HOST_AUTHENTICATION_TOKEN_SOURCE_PAT"` # Schema ## GetRunnerConfigurationSchema `client.Runners.Configurations.Schema.Get(ctx, body) (*RunnerConfigurationSchemaGetResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/GetRunnerConfigurationSchema` Gets the latest runner configuration schema. Use this method to: - View available settings - Check configuration options - Validate configurations ### Examples - Get schema: Retrieves configuration schema for a runner. ```yaml runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationSchemaGetParams` - `RunnerID param.Field[string]` ### Returns - `type RunnerConfigurationSchemaGetResponse struct{…}` - `Schema RunnerConfigurationSchema` - `EnvironmentClasses []RunnerConfigurationSchemaEnvironmentClass` - `ID string` - `Bool RunnerConfigurationSchemaEnvironmentClassesBool` - `Default bool` - `Description string` - `Display RunnerConfigurationSchemaEnvironmentClassesDisplay` - `Default string` - `Enum RunnerConfigurationSchemaEnvironmentClassesEnum` - `Default string` deprecated, will be removed, use default_value instead - `DefaultValue RunnerConfigurationSchemaEnvironmentClassesEnumDefaultValue` - `Detail string` - `Subtitle string` - `Title string` - `PossibleValues []RunnerConfigurationSchemaEnvironmentClassesEnumPossibleValue` - `Detail string` - `Subtitle string` - `Title string` - `Values []string` deprecated, will be removed, use possible_values instead - `Int RunnerConfigurationSchemaEnvironmentClassesInt` - `Default int64` - `Max int64` - `Min int64` - `Name string` - `Required bool` - `Secret bool` - `String RunnerConfigurationSchemaEnvironmentClassesString` - `Default string` - `Pattern string` - `RunnerConfig []RunnerConfigurationSchemaRunnerConfig` - `ID string` - `Bool RunnerConfigurationSchemaRunnerConfigBool` - `Default bool` - `Description string` - `Display RunnerConfigurationSchemaRunnerConfigDisplay` - `Default string` - `Enum RunnerConfigurationSchemaRunnerConfigEnum` - `Default string` deprecated, will be removed, use default_value instead - `DefaultValue RunnerConfigurationSchemaRunnerConfigEnumDefaultValue` - `Detail string` - `Subtitle string` - `Title string` - `PossibleValues []RunnerConfigurationSchemaRunnerConfigEnumPossibleValue` - `Detail string` - `Subtitle string` - `Title string` - `Values []string` deprecated, will be removed, use possible_values instead - `Int RunnerConfigurationSchemaRunnerConfigInt` - `Default int64` - `Max int64` - `Min int64` - `Name string` - `Required bool` - `Secret bool` - `String RunnerConfigurationSchemaRunnerConfigString` - `Default string` - `Pattern string` - `Scm []RunnerConfigurationSchemaScm` - `DefaultHosts []string` - `Name string` - `OAuth RunnerConfigurationSchemaScmOAuth` - `CallbackURL string` callback_url is the URL the OAuth app will redirect to after the user has authenticated. - `Pat RunnerConfigurationSchemaScmPat` - `Description string` description is a human-readable description of the PAT. - `DocsLink string` docs_link is a link to the documentation on how to create a PAT for this SCM system. - `ScmID string` - `Version string` The schema version ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) schema, err := client.Runners.Configurations.Schema.Get(context.TODO(), gitpod.RunnerConfigurationSchemaGetParams{ RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", schema.Schema) } ``` #### Response ```json { "schema": { "environmentClasses": [ { "id": "id", "bool": { "default": true }, "description": "description", "display": { "default": "default" }, "enum": { "default": "default", "defaultValue": { "detail": "detail", "subtitle": "subtitle", "title": "title" }, "possibleValues": [ { "detail": "detail", "subtitle": "subtitle", "title": "title" } ], "values": [ "string" ] }, "int": { "default": 0, "max": 0, "min": 0 }, "name": "name", "required": true, "secret": true, "string": { "default": "default", "pattern": "pattern" } } ], "runnerConfig": [ { "id": "id", "bool": { "default": true }, "description": "description", "display": { "default": "default" }, "enum": { "default": "default", "defaultValue": { "detail": "detail", "subtitle": "subtitle", "title": "title" }, "possibleValues": [ { "detail": "detail", "subtitle": "subtitle", "title": "title" } ], "values": [ "string" ] }, "int": { "default": 0, "max": 0, "min": 0 }, "name": "name", "required": true, "secret": true, "string": { "default": "default", "pattern": "pattern" } } ], "scm": [ { "defaultHosts": [ "string" ], "name": "name", "oauth": { "callbackUrl": "callbackUrl" }, "pat": { "description": "description", "docsLink": "docsLink" }, "scmId": "scmId" } ], "version": "version" } } ``` ## Domain Types ### Runner Configuration Schema - `type RunnerConfigurationSchema struct{…}` - `EnvironmentClasses []RunnerConfigurationSchemaEnvironmentClass` - `ID string` - `Bool RunnerConfigurationSchemaEnvironmentClassesBool` - `Default bool` - `Description string` - `Display RunnerConfigurationSchemaEnvironmentClassesDisplay` - `Default string` - `Enum RunnerConfigurationSchemaEnvironmentClassesEnum` - `Default string` deprecated, will be removed, use default_value instead - `DefaultValue RunnerConfigurationSchemaEnvironmentClassesEnumDefaultValue` - `Detail string` - `Subtitle string` - `Title string` - `PossibleValues []RunnerConfigurationSchemaEnvironmentClassesEnumPossibleValue` - `Detail string` - `Subtitle string` - `Title string` - `Values []string` deprecated, will be removed, use possible_values instead - `Int RunnerConfigurationSchemaEnvironmentClassesInt` - `Default int64` - `Max int64` - `Min int64` - `Name string` - `Required bool` - `Secret bool` - `String RunnerConfigurationSchemaEnvironmentClassesString` - `Default string` - `Pattern string` - `RunnerConfig []RunnerConfigurationSchemaRunnerConfig` - `ID string` - `Bool RunnerConfigurationSchemaRunnerConfigBool` - `Default bool` - `Description string` - `Display RunnerConfigurationSchemaRunnerConfigDisplay` - `Default string` - `Enum RunnerConfigurationSchemaRunnerConfigEnum` - `Default string` deprecated, will be removed, use default_value instead - `DefaultValue RunnerConfigurationSchemaRunnerConfigEnumDefaultValue` - `Detail string` - `Subtitle string` - `Title string` - `PossibleValues []RunnerConfigurationSchemaRunnerConfigEnumPossibleValue` - `Detail string` - `Subtitle string` - `Title string` - `Values []string` deprecated, will be removed, use possible_values instead - `Int RunnerConfigurationSchemaRunnerConfigInt` - `Default int64` - `Max int64` - `Min int64` - `Name string` - `Required bool` - `Secret bool` - `String RunnerConfigurationSchemaRunnerConfigString` - `Default string` - `Pattern string` - `Scm []RunnerConfigurationSchemaScm` - `DefaultHosts []string` - `Name string` - `OAuth RunnerConfigurationSchemaScmOAuth` - `CallbackURL string` callback_url is the URL the OAuth app will redirect to after the user has authenticated. - `Pat RunnerConfigurationSchemaScmPat` - `Description string` description is a human-readable description of the PAT. - `DocsLink string` docs_link is a link to the documentation on how to create a PAT for this SCM system. - `ScmID string` - `Version string` The schema version # Scm Integrations ## CreateSCMIntegration `client.Runners.Configurations.ScmIntegrations.New(ctx, body) (*RunnerConfigurationScmIntegrationNewResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/CreateSCMIntegration` Creates a new SCM integration for a runner. Use this method to: - Configure source control access - Set up repository integrations - Enable code synchronization ### Examples - Create GitHub integration: Sets up GitHub SCM integration. ```yaml runnerId: "d2c94c27-3b76-4a42-b88c-95a85e392c68" scmId: "github" host: "github.com" oauthClientId: "client_id" oauthPlaintextClientSecret: "client_secret" ``` ### Parameters - `body RunnerConfigurationScmIntegrationNewParams` - `Host param.Field[string]` - `IssuerURL param.Field[string]` issuer_url can be set to override the authentication provider URL, if it doesn't match the SCM host. - `OAuthClientID param.Field[string]` oauth_client_id is the OAuth app's client ID, if OAuth is configured. If configured, oauth_plaintext_client_secret must also be set. - `OAuthPlaintextClientSecret param.Field[string]` oauth_plaintext_client_secret is the OAuth app's client secret in clear text. This will first be encrypted with the runner's public key before being stored. - `Pat param.Field[bool]` - `RunnerID param.Field[string]` - `ScmID param.Field[string]` scm_id references the scm_id in the runner's configuration schema that this integration is for - `VirtualDirectory param.Field[string]` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Returns - `type RunnerConfigurationScmIntegrationNewResponse struct{…}` - `ID string` id is a uniquely generated identifier for the SCM integration ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) scmIntegration, err := client.Runners.Configurations.ScmIntegrations.New(context.TODO(), gitpod.RunnerConfigurationScmIntegrationNewParams{ Host: gitpod.F("github.com"), OAuthClientID: gitpod.F("client_id"), OAuthPlaintextClientSecret: gitpod.F("client_secret"), RunnerID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), ScmID: gitpod.F("github"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", scmIntegration.ID) } ``` #### Response ```json { "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e" } ``` ## DeleteSCMIntegration `client.Runners.Configurations.ScmIntegrations.Delete(ctx, body) (*RunnerConfigurationScmIntegrationDeleteResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/DeleteSCMIntegration` Deletes an SCM integration. Use this method to: - Remove unused integrations - Clean up configurations - Revoke SCM access ### Examples - Delete integration: Removes an SCM integration. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationScmIntegrationDeleteParams` - `ID param.Field[string]` ### Returns - `type RunnerConfigurationScmIntegrationDeleteResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) scmIntegration, err := client.Runners.Configurations.ScmIntegrations.Delete(context.TODO(), gitpod.RunnerConfigurationScmIntegrationDeleteParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", scmIntegration) } ``` #### Response ```json {} ``` ## ListSCMIntegrations `client.Runners.Configurations.ScmIntegrations.List(ctx, params) (*IntegrationsPage[ScmIntegration], error)` **post** `/gitpod.v1.RunnerConfigurationService/ListSCMIntegrations` Lists SCM integrations for a runner. Use this method to: - View all integrations - Monitor integration status - Check available SCMs ### Examples - List integrations: Shows all SCM integrations. ```yaml filter: runnerIds: ["d2c94c27-3b76-4a42-b88c-95a85e392c68"] pagination: pageSize: 20 ``` ### Parameters - `params RunnerConfigurationScmIntegrationListParams` - `Token param.Field[string]` Query param - `PageSize param.Field[int64]` Query param - `Filter param.Field[RunnerConfigurationScmIntegrationListParamsFilter]` Body param - `RunnerIDs []string` runner_ids filters the response to only SCM integrations of these Runner IDs - `Pagination param.Field[RunnerConfigurationScmIntegrationListParamsPagination]` Body param: pagination contains the pagination options for listing scm integrations - `Token string` Token for the next set of results that was returned as next_token of a PaginationResponse - `PageSize int64` Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. ### Returns - `type ScmIntegration struct{…}` - `ID string` id is the unique identifier of the SCM integration - `Host string` - `OAuth ScmIntegrationOAuthConfig` - `ClientID string` client_id is the OAuth app's client ID in clear text. - `EncryptedClientSecret string` encrypted_client_secret is the OAuth app's secret encrypted with the runner's public key. - `IssuerURL string` issuer_url is used to override the authentication provider URL, if it doesn't match the SCM host. +optional if not set, this account is owned by the installation. - `Pat bool` - `RunnerID string` - `ScmID string` scm_id references the scm_id in the runner's configuration schema that this integration is for - `VirtualDirectory string` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) page, err := client.Runners.Configurations.ScmIntegrations.List(context.TODO(), gitpod.RunnerConfigurationScmIntegrationListParams{ Filter: gitpod.F(gitpod.RunnerConfigurationScmIntegrationListParamsFilter{ RunnerIDs: gitpod.F([]string{"d2c94c27-3b76-4a42-b88c-95a85e392c68"}), }), Pagination: gitpod.F(gitpod.RunnerConfigurationScmIntegrationListParamsPagination{ PageSize: gitpod.F(int64(20)), }), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", page) } ``` #### Response ```json { "integrations": [ { "id": "id", "host": "host", "oauth": { "clientId": "clientId", "encryptedClientSecret": "U3RhaW5sZXNzIHJvY2tz", "issuerUrl": "issuerUrl" }, "pat": true, "runnerId": "runnerId", "scmId": "scmId", "virtualDirectory": "virtualDirectory" } ], "pagination": { "nextToken": "nextToken" } } ``` ## GetSCMIntegration `client.Runners.Configurations.ScmIntegrations.Get(ctx, body) (*RunnerConfigurationScmIntegrationGetResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/GetSCMIntegration` Gets details about a specific SCM integration. Use this method to: - View integration settings - Check integration status - Verify configuration ### Examples - Get integration details: Retrieves information about a specific integration. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" ``` ### Parameters - `body RunnerConfigurationScmIntegrationGetParams` - `ID param.Field[string]` ### Returns - `type RunnerConfigurationScmIntegrationGetResponse struct{…}` - `Integration ScmIntegration` - `ID string` id is the unique identifier of the SCM integration - `Host string` - `OAuth ScmIntegrationOAuthConfig` - `ClientID string` client_id is the OAuth app's client ID in clear text. - `EncryptedClientSecret string` encrypted_client_secret is the OAuth app's secret encrypted with the runner's public key. - `IssuerURL string` issuer_url is used to override the authentication provider URL, if it doesn't match the SCM host. +optional if not set, this account is owned by the installation. - `Pat bool` - `RunnerID string` - `ScmID string` scm_id references the scm_id in the runner's configuration schema that this integration is for - `VirtualDirectory string` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) scmIntegration, err := client.Runners.Configurations.ScmIntegrations.Get(context.TODO(), gitpod.RunnerConfigurationScmIntegrationGetParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", scmIntegration.Integration) } ``` #### Response ```json { "integration": { "id": "id", "host": "host", "oauth": { "clientId": "clientId", "encryptedClientSecret": "U3RhaW5sZXNzIHJvY2tz", "issuerUrl": "issuerUrl" }, "pat": true, "runnerId": "runnerId", "scmId": "scmId", "virtualDirectory": "virtualDirectory" } } ``` ## UpdateSCMIntegration `client.Runners.Configurations.ScmIntegrations.Update(ctx, body) (*RunnerConfigurationScmIntegrationUpdateResponse, error)` **post** `/gitpod.v1.RunnerConfigurationService/UpdateSCMIntegration` Updates an existing SCM integration. Use this method to: - Modify integration settings - Update credentials - Change configuration ### Examples - Update integration: Updates OAuth credentials. ```yaml id: "d2c94c27-3b76-4a42-b88c-95a85e392c68" oauthClientId: "new_client_id" oauthPlaintextClientSecret: "new_client_secret" ``` ### Parameters - `body RunnerConfigurationScmIntegrationUpdateParams` - `ID param.Field[string]` - `IssuerURL param.Field[string]` issuer_url can be set to override the authentication provider URL, if it doesn't match the SCM host. - `OAuthClientID param.Field[string]` oauth_client_id can be set to update the OAuth app's client ID. If an empty string is set, the OAuth configuration will be removed (regardless of whether a client secret is set), and any existing Host Authentication Tokens for the SCM integration's runner and host that were created using the OAuth app will be deleted. This might lead to users being unable to access their repositories until they re-authenticate. - `OAuthPlaintextClientSecret param.Field[string]` oauth_plaintext_client_secret can be set to update the OAuth app's client secret. The cleartext secret will be encrypted with the runner's public key before being stored. - `Pat param.Field[bool]` pat can be set to enable or disable Personal Access Tokens support. When disabling PATs, any existing Host Authentication Tokens for the SCM integration's runner and host that were created using a PAT will be deleted. This might lead to users being unable to access their repositories until they re-authenticate. - `VirtualDirectory param.Field[string]` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Returns - `type RunnerConfigurationScmIntegrationUpdateResponse interface{…}` ### Example ```go package main import ( "context" "fmt" "github.com/gitpod-io/gitpod-sdk-go" "github.com/gitpod-io/gitpod-sdk-go/option" ) func main() { client := gitpod.NewClient( option.WithBearerToken("My Bearer Token"), ) scmIntegration, err := client.Runners.Configurations.ScmIntegrations.Update(context.TODO(), gitpod.RunnerConfigurationScmIntegrationUpdateParams{ ID: gitpod.F("d2c94c27-3b76-4a42-b88c-95a85e392c68"), OAuthClientID: gitpod.F("new_client_id"), OAuthPlaintextClientSecret: gitpod.F("new_client_secret"), }) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", scmIntegration) } ``` #### Response ```json {} ``` ## Domain Types ### Scm Integration - `type ScmIntegration struct{…}` - `ID string` id is the unique identifier of the SCM integration - `Host string` - `OAuth ScmIntegrationOAuthConfig` - `ClientID string` client_id is the OAuth app's client ID in clear text. - `EncryptedClientSecret string` encrypted_client_secret is the OAuth app's secret encrypted with the runner's public key. - `IssuerURL string` issuer_url is used to override the authentication provider URL, if it doesn't match the SCM host. +optional if not set, this account is owned by the installation. - `Pat bool` - `RunnerID string` - `ScmID string` scm_id references the scm_id in the runner's configuration schema that this integration is for - `VirtualDirectory string` virtual_directory is the virtual directory path for Azure DevOps Server (e.g., "/tfs"). This field is only used for Azure DevOps Server SCM integrations and should be empty for other SCM types. Azure DevOps Server APIs work without collection when PAT scope is 'All accessible organizations'. ### Scm Integration OAuth Config - `type ScmIntegrationOAuthConfig struct{…}` - `ClientID string` client_id is the OAuth app's client ID in clear text. - `EncryptedClientSecret string` encrypted_client_secret is the OAuth app's secret encrypted with the runner's public key. - `IssuerURL string` issuer_url is used to override the authentication provider URL, if it doesn't match the SCM host. +optional if not set, this account is owned by the installation.